Index: /trunk/about.php
===================================================================
--- /trunk/about.php	(revision 861)
+++ /trunk/about.php	(revision 862)
@@ -40,9 +40,24 @@
 $template->assign_vars(
   array(
-    'L_ABOUT' => $lang['about_message'],
     'U_HOME' => add_session_id(PHPWG_ROOT_PATH.'category.php')
     )
   );
 
+// language files
+$user_langdir = PHPWG_ROOT_PATH.'language/'.$user['language'];
+$conf_langdir = PHPWG_ROOT_PATH.'language/'.$conf['default_language'];
+
+if (file_exists($user_langdir.'/about.html'))
+{
+  $html_file = $user_langdir.'/about.html';
+}
+else
+{
+  $html_file = $conf_langdir.'/about.html';
+}
+
+$template->set_filenames(array('about_content' => $html_file));
+$template->assign_var_from_handle('ABOUT_MESSAGE', 'about_content');
+  
 $template->parse('about');
 include(PHPWG_ROOT_PATH.'include/page_tail.php');
Index: /trunk/admin.php
===================================================================
--- /trunk/admin.php	(revision 861)
+++ /trunk/admin.php	(revision 862)
@@ -57,5 +57,5 @@
 $opt_link = $link_start.'cat_options&amp;section=';
 //----------------------------------------------------- template initialization
-$title = l10n('PhpWebGallery administration'); // for include/page_header.php
+$title = l10n('PhpWebGallery Administration'); // for include/page_header.php
 $page['gallery_title'] = l10n('PhpWebGallery Administration');
 $page['body_id'] = 'theAdminPage';
Index: /trunk/admin/cat_modify.php
===================================================================
--- /trunk/admin/cat_modify.php	(revision 861)
+++ /trunk/admin/cat_modify.php	(revision 862)
@@ -158,15 +158,10 @@
   'L_REMOTE_SITE'=>$lang['remote_site'],
   'L_EDIT_COMMENT'=>$lang['description'],
-  'L_EDIT_CAT_OPTIONS'=>$lang['cat_options'],
   'L_EDIT_STATUS'=>$lang['conf_access'],
-  'L_EDIT_STATUS_INFO'=>$lang['cat_access_info'],
   'L_STATUS_PUBLIC'=>$lang['public'],
   'L_STATUS_PRIVATE'=>$lang['private'],
   'L_EDIT_LOCK'=>$lang['lock'],
-  'L_EDIT_LOCK_INFO'=>$lang['editcat_lock_info'],
   'L_EDIT_UPLOADABLE'=>$lang['editcat_uploadable'],
-  'L_EDIT_UPLOADABLE_INFO'=>$lang['editcat_uploadable_info'],
   'L_EDIT_COMMENTABLE'=>$lang['comments'],
-  'L_EDIT_COMMENTABLE_INFO'=>$lang['editcat_commentable_info'],
   'L_YES'=>$lang['yes'],
   'L_NO'=>$lang['no'],
@@ -178,4 +173,5 @@
   'U_CHILDREN'=>
     add_session_id($cat_list_url.'&amp;parent_id='.$category['id']),
+  'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=cat_modify',
    
   'F_ACTION'=>add_session_id($form_action)
Index: /trunk/admin/cat_options.php
===================================================================
--- /trunk/admin/cat_options.php	(revision 861)
+++ /trunk/admin/cat_options.php	(revision 862)
@@ -151,4 +151,6 @@
     'L_SUBMIT'=>$lang['submit'],
     'L_RESET'=>$lang['reset'],
+
+    'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=cat_options',
     
     'F_ACTION'=>add_session_id($base_url.$page['section'])
@@ -194,5 +196,4 @@
         'L_CAT_OPTIONS_TRUE' => $lang['authorized'],
         'L_CAT_OPTIONS_FALSE' => $lang['forbidden'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_upload_info'],
         )
       );
@@ -216,5 +217,4 @@
         'L_CAT_OPTIONS_TRUE' => $lang['authorized'],
         'L_CAT_OPTIONS_FALSE' => $lang['forbidden'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_comments_info'],
         )
       );
@@ -238,5 +238,4 @@
         'L_CAT_OPTIONS_TRUE' => $lang['unlocked'],
         'L_CAT_OPTIONS_FALSE' => $lang['locked'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_lock_info'],
         )
       );
@@ -260,5 +259,4 @@
         'L_CAT_OPTIONS_TRUE' => $lang['cat_public'],
         'L_CAT_OPTIONS_FALSE' => $lang['cat_private'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_status_info'],
         )
       );
@@ -282,6 +280,5 @@
         'L_SECTION' => l10n('Representative'),
         'L_CAT_OPTIONS_TRUE' => l10n('singly represented'),
-        'L_CAT_OPTIONS_FALSE' => l10n('randomly represented'),
-        'L_CAT_OPTIONS_INFO' => l10n('')
+        'L_CAT_OPTIONS_FALSE' => l10n('randomly represented')
         )
       );
Index: /trunk/admin/cat_perm.php
===================================================================
--- /trunk/admin/cat_perm.php	(revision 861)
+++ /trunk/admin/cat_perm.php	(revision 862)
@@ -207,4 +207,5 @@
         'admin.php?page=cat_modify&amp;cat_id='
         ),
+    'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=cat_perm',
     'F_ACTION' =>
       add_session_id(
Index: /trunk/admin/help.php
===================================================================
--- /trunk/admin/help.php	(revision 861)
+++ /trunk/admin/help.php	(revision 862)
@@ -25,22 +25,21 @@
 // | USA.                                                                  |
 // +-----------------------------------------------------------------------+
+
 include_once( PHPWG_ROOT_PATH.'admin/include/isadmin.inc.php' );
-//----------------------------------------------------- template initialization
-$template->set_filenames( array('help'=>'admin/help.tpl') );
 
-//----------------------------------------------------- help categories display
-$categories = array('images','thumbnails','database','access','groups',
-                    'remote','upload','virtual','infos');
-foreach ($categories as $category)
+// language files
+$user_langdir = PHPWG_ROOT_PATH.'language/'.$user['language'];
+$conf_langdir = PHPWG_ROOT_PATH.'language/'.$conf['default_language'];
+
+if (file_exists($user_langdir.'/help.html'))
 {
-  $template->assign_block_vars(
-    'cat',
-    array('NAME'=>$lang['help_'.$category.'_title']));
-  
-  foreach ($lang['help_'.$category] as $item)
-  {
-    $template->assign_block_vars('cat.item', array('CONTENT'=>$item));
-  }
+  $html_file = $user_langdir.'/help.html';
 }
-$template->assign_var_from_handle('ADMIN_CONTENT', 'help');
+else
+{
+  $html_file = $conf_langdir.'/help.html';
+}
+
+$template->set_filenames(array('help_content' => $html_file));
+$template->assign_var_from_handle('ADMIN_CONTENT', 'help_content');
 ?>
Index: /trunk/admin/include/functions.php
===================================================================
--- /trunk/admin/include/functions.php	(revision 861)
+++ /trunk/admin/include/functions.php	(revision 862)
@@ -28,42 +28,4 @@
 include(PHPWG_ROOT_PATH.'admin/include/functions_metadata.php');
 
-$tab_ext_create_TN = array ( 'jpg', 'png', 'JPG', 'PNG' );
-
-// is_image returns true if the given $filename (including the path) is a
-// picture according to its format and its extension.
-// As GD library can only generate pictures from jpeg and png files, if you
-// ask if the filename is an image for thumbnail creation (second parameter
-// set to true), the only authorized formats are jpeg and png.
-function is_image( $filename, $create_thumbnail = false )
-{
-  global $conf, $tab_ext_create_TN;
-
-  if (is_file($filename)
-      and in_array(get_extension($filename), $conf['picture_ext']))
-  {
-    $size = getimagesize( $filename );
-    // $size[2] == 1 means GIF
-    // $size[2] == 2 means JPG
-    // $size[2] == 3 means PNG
-    if ( !$create_thumbnail )
-    {
-      if ( in_array( get_extension( $filename ), $conf['picture_ext'] )
-           and ( $size[2] == 1 or $size[2] == 2 or $size[2] == 3 ) )
-      {
-        return true;
-      }
-    }
-    else
-    {
-      if ( in_array( get_extension( $filename ), $tab_ext_create_TN )
-           and ( $size[2] == 2 or $size[2] == 3 ) )
-      {
-        return true;
-      }
-    }
-  }
-  return false;
-}
-
 /**
  * returns an array with all picture files according to $conf['file_ext']
@@ -142,20 +104,4 @@
   return $pictures;
 }
-
-function TN_exists( $dir, $file )
-{
-  global $conf;
-
-  $filename = get_filename_wo_extension( $file );
-  foreach ( $conf['picture_ext'] as $ext ) {
-    $test = $dir.'/thumbnail/'.$conf['prefix_thumbnail'].$filename.'.'.$ext;
-    if ( is_file ( $test ) )
-    {
-      return $ext;
-    }
-  }
-  return false;
-}
-	
 
 // The function delete_site deletes a site and call the function
@@ -553,19 +499,4 @@
 }
 
-function check_date_format( $date )
-{
-  // date arrives at this format : DD/MM/YYYY
-  @list($day,$month,$year) = explode( '/', $date );
-  return @checkdate( $month, $day, $year );
-}
-
-function date_convert( $date )
-{
-  // date arrives at this format : DD/MM/YYYY
-  // It must be transformed in YYYY-MM-DD
-  list($day,$month,$year) = explode( '/', $date );
-  return $year.'-'.$month.'-'.$day;
-}
-
 function date_convert_back( $date )
 {
@@ -600,35 +531,4 @@
         )
       );
-}
-
-/**
- * returns an array containing sub-directories which can be a category
- *
- * directories nammed "thumbnail", "pwg_high" or "pwg_representative" are
- * omitted
- *
- * @param string $basedir
- * @return array
- */
-function get_category_directories( $basedir )
-{
-  $sub_dirs = array();
-  
-  if ( $opendir = opendir( $basedir ) )
-  {
-    while ( $file = readdir( $opendir ) )
-    {
-      if ($file != '.'
-          and $file != '..'
-          and $file != 'thumbnail'
-          and $file != 'pwg_high'
-          and $file != 'pwg_representative'
-          and is_dir($basedir.'/'.$file))
-      {
-        array_push( $sub_dirs, $file );
-      }
-    }
-  }
-  return $sub_dirs;
 }
 
Index: /trunk/admin/include/functions_metadata.php
===================================================================
--- /trunk/admin/include/functions_metadata.php	(revision 861)
+++ /trunk/admin/include/functions_metadata.php	(revision 862)
@@ -222,27 +222,3 @@
   return $files;
 }
-
-// used_metadata string is displayed to inform admin which metadata will be
-// used from files for synchronization
-function get_used_metadata_list()
-{
-  global $conf;
-  
-  $used_metadata = array('filesize', 'width', 'height');
-
-  if ($conf['use_exif'])
-  {
-    array_push($used_metadata, 'date_creation');
-  }
-
-  if ($conf['use_iptc'])
-  {
-    foreach (array_keys($conf['use_iptc_mapping']) as $key)
-    {
-      array_push($used_metadata, $key);
-    }
-  }
-
-  return array_unique($used_metadata);
-}
 ?>
Index: /trunk/admin/thumbnail.php
===================================================================
--- /trunk/admin/thumbnail.php	(revision 861)
+++ /trunk/admin/thumbnail.php	(revision 862)
@@ -170,11 +170,5 @@
   'L_PARAMS'=>$lang['tn_params_title'],
   'L_GD'=>$lang['tn_params_GD'],
-  'L_GD_INFO'=>$lang['tn_params_GD_info'],
-  'L_WIDTH_INFO'=>$lang['tn_params_width_info'],
-  'L_HEIGHT_INFO'=>$lang['tn_params_height_info'],
   'L_CREATE'=>$lang['tn_params_create'],
-  'L_CREATE_INFO'=>$lang['tn_params_create_info'],
-  'L_FORMAT'=>$lang['tn_params_format'],
-  'L_FORMAT_INFO'=>$lang['tn_params_format_info'],
   'L_SUBMIT'=>$lang['submit'],
   'L_REMAINING'=>$lang['tn_alone_title'],
@@ -186,4 +180,6 @@
   'L_TN_AVERAGE'=>$lang['tn_stats_mean'],
   'L_ALL'=>$lang['tn_all'],
+
+  'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=thumbnail',
   
   'T_STYLE'=>$user['template']
Index: /trunk/admin/user_list.php
===================================================================
--- /trunk/admin/user_list.php	(revision 861)
+++ /trunk/admin/user_list.php	(revision 862)
@@ -294,4 +294,6 @@
     'L_DELETE' => $lang['user_delete'],
     'L_DELETE_HINT' => $lang['user_delete_hint'],
+
+    'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=user_list',
     
     'F_ADD_ACTION' => $base_url,
Index: /trunk/doc/ChangeLog
===================================================================
--- /trunk/doc/ChangeLog	(revision 861)
+++ /trunk/doc/ChangeLog	(revision 862)
@@ -1,2 +1,21 @@
+2005-09-03 Pierrick LE GALL
+
+	* improvement: long localized messages are in HTML files instead
+	of $lang array. This is the case of admin/help and about pages.
+
+	* deletion: of unused functions (ts_to_mysqldt, is_image,
+	TN_exists, check_date_format, date_convert,
+	get_category_directories, get_used_metadata_list, array_remove,
+	pwg_write_debug, get_group_restrictions,
+	get_all_group_restrictions, is_group_allowed, style_select,
+	deprecated_getAttribute).
+
+	* new: many new contextual help pages to replace descriptions
+	previously included in pages.
+
+	* modification: reorganisation of language files. Deletion of
+	unused language keys, alphabetical sort. No faq.lang.php anymore
+	(replaced by help.html). Only done for en_UK.iso-8859-1.
+
 2005-09-03 Pierrick LE GALL
 
Index: /trunk/feed.php
===================================================================
--- /trunk/feed.php	(revision 861)
+++ /trunk/feed.php	(revision 862)
@@ -216,16 +216,4 @@
 
 /**
- * creates a MySQL datetime format (2005-07-14 23:01:37) from a Unix
- * timestamp (number of seconds since 1970-01-01 00:00:00 GMT)
- *
- * @param int unix timestamp
- * @return string mysql datetime format
- */
-function ts_to_mysqldt($ts)
-{
-  return date('Y-m-d H:i:s', $ts);
-}
-
-/**
  * creates a Unix timestamp (number of seconds since 1970-01-01 00:00:00
  * GMT) from a MySQL datetime format (2005-07-14 23:01:37)
Index: /trunk/include/common.inc.php
===================================================================
--- /trunk/include/common.inc.php	(revision 861)
+++ /trunk/include/common.inc.php	(revision 862)
@@ -182,5 +182,5 @@
 if (defined('IN_ADMIN') and IN_ADMIN)
 {
-  foreach (array('admin', 'faq') as $section)
+  foreach (array('admin') as $section)
   {
     if (file_exists($user_langdir.'/'.$section.'.lang.php'))
Index: /trunk/include/config_default.inc.php
===================================================================
--- /trunk/include/config_default.inc.php	(revision 861)
+++ /trunk/include/config_default.inc.php	(revision 862)
@@ -177,5 +177,6 @@
 $conf['gallery_url'] = 'http://demo.phpwebgallery.net';
 
-// prefix_thumbnail : string before filename
+// prefix_thumbnail : string before filename. Thumbnail's prefix must only
+// contain characters among : a to z (case insensitive), "-" or "_".
 $conf['prefix_thumbnail'] = 'TN-';
 
Index: /trunk/include/functions.inc.php
===================================================================
--- /trunk/include/functions.inc.php	(revision 861)
+++ /trunk/include/functions.inc.php	(revision 862)
@@ -103,15 +103,4 @@
 }
 
-// array_remove removes a value from the given array if the value existed in
-// this array.
-function array_remove( $array, $value )
-{
-  $output = array();
-  foreach ( $array as $v ) {
-    if ( $v != $value ) array_push( $output, $v );
-  }
-  return $output;
-}
-
 // The function get_moment returns a float value coresponding to the number
 // of seconds since the unix epoch (1st January 1970) and the microseconds
@@ -434,14 +423,4 @@
 }
 
-function pwg_write_debug()
-{
-  global $debug;
-  
-  $fp = @fopen( './log/debug.log', 'a+' );
-  fwrite( $fp, "\n\n" );
-  fwrite( $fp, $debug );
-  fclose( $fp );
-}
-
 function pwg_query($query)
 {
@@ -735,5 +714,5 @@
   global $lang, $conf;
 
-  if ($conf['debug_l10n'])
+  if ($conf['debug_l10n'] and !isset($lang[$key]))
   {
     echo '[l10n] language key "'.$key.'" is not defined<br />';
Index: /trunk/include/functions_group.inc.php
===================================================================
--- /trunk/include/functions_group.inc.php	(revision 861)
+++ /trunk/include/functions_group.inc.php	(revision 862)
@@ -26,84 +26,5 @@
 // +-----------------------------------------------------------------------+
 
-// get_group_restrictions returns an array containing all unaccessible
-// category ids.
-function get_group_restrictions( $group_id )
-{
-  // 1. retrieving ids of private categories
-  $query = 'SELECT id FROM '.CATEGORIES_TABLE;
-  $query.= " WHERE status = 'private'";
-  $query.= ';';
-  $result = pwg_query( $query );
-  $privates = array();
-  while ( $row = mysql_fetch_array( $result ) )
-  {
-    array_push( $privates, $row['id'] );
-  }
-  // 2. retrieving all authorized categories for the group
-  $authorized = array();
-  $query = 'SELECT cat_id FROM '.GROUP_ACCESS_TABLE;
-  $query.= ' WHERE group_id = '.$group_id;
-  $query.= ';';
-  $result = pwg_query( $query );
-  while ( $row = mysql_fetch_array( $result ) )
-  {
-    array_push( $authorized, $row['cat_id'] );
-  }
+// with 1.5 preparation, no group dedicated function is used.
 
-  $forbidden = array();
-  foreach ( $privates as $private ) {
-    if ( !in_array( $private, $authorized ) )
-    {
-      array_push( $forbidden, $private );
-    }
-  }
-
-  return $forbidden;
-}
-
-// get_all_group_restrictions returns an array with ALL unaccessible
-// category ids, including sub-categories
-function get_all_group_restrictions( $group_id )
-{
-  $restricted_cats = get_group_restrictions( $group_id );
-  foreach ( $restricted_cats as $restricted_cat ) {
-    $sub_restricted_cats = get_subcats_id( $restricted_cat );
-    foreach ( $sub_restricted_cats as $sub_restricted_cat ) {
-      array_push( $restricted_cats, $sub_restricted_cat );
-    }
-  }
-  return $restricted_cats;
-}
-
-// The function is_group_allowed returns :
-//      - 0 : if the category is allowed with this $restrictions array
-//      - 1 : if this category is not allowed
-//      - 2 : if an uppercat category is not allowed
-function is_group_allowed( $category_id, $restrictions )
-{
-  $lowest_category_id = $category_id;
-                
-  $is_root = false;
-  while ( !$is_root and !in_array( $category_id, $restrictions ) )
-  {
-    $query = 'SELECT id_uppercat FROM '.CATEGORIES_TABLE;
-    $query.= ' WHERE id = '.$category_id;
-    $query.= ';';
-    $row = mysql_fetch_array( pwg_query( $query ) );
-    if ( !isset( $row['id_uppercat'] ) ) $row['id_uppercat'] = '';
-    if ( $row['id_uppercat'] == '' ) $is_root = true;
-    $category_id = $row['id_uppercat'];
-  }
-                
-  if ( in_array( $lowest_category_id, $restrictions ) )
-  {
-    return 1;
-  }
-  if ( in_array( $category_id, $restrictions ) )
-  {
-    return 2;
-  }
-  // this group is allowed to go in this category
-  return 0;
-}
 ?>
Index: /trunk/include/functions_html.inc.php
===================================================================
--- /trunk/include/functions_html.inc.php	(revision 861)
+++ /trunk/include/functions_html.inc.php	(revision 862)
@@ -204,22 +204,4 @@
 }
 
-//
-// Pick a template/theme combo, 
-//
-function style_select($default_style, $select_name = "style")
-{
-  $templates = get_templates();
-
-  $style_selected = '<select name="' . $select_name . '" >';
-  foreach ($templates as $template)
-  {
-    $selected = ( $template == $default_style ) ? ' selected="selected"' : '';
-    $style_selected.= '<option value="'.$template.'"'.$selected.'>';
-    $style_selected.= $template.'</option>';
-  }
-  $style_selected .= '</select>';
-  return $style_selected;
-}
-
 /**
  * returns the list of categories as a HTML string
Index: /trunk/include/functions_xml.inc.php
===================================================================
--- /trunk/include/functions_xml.inc.php	(revision 861)
+++ /trunk/include/functions_xml.inc.php	(revision 862)
@@ -57,26 +57,4 @@
   else return '';
 }
-
-function deprecated_getAttribute( $element, $attribute )
-{
-  // Retrieving string with tag name and all attributes
-  $regex = '/^<\w+( '.ATT_REG.'="'.VAL_REG.'")*/';
-  preg_match( $regex, $element, $out );
-
-  // Splitting string for retrieving separately attributes
-  // and corresponding values
-  $regex = '/('.ATT_REG.')="('.VAL_REG.')"/';
-  preg_match_all( $regex, $out[0], $out );
-
-  // Searching and returning the value of the requested attribute
-  for ( $i = 0; $i < sizeof( $out[0] ); $i++ )
-  {
-    if ( $out[1][$i] == $attribute )
-    {
-      return $out[2][$i];
-    }
-  }
-  return '';
-}
 	
 // The function getChild returns the first child
